-- BuffCheck_Data.lua
-- by Mithrandir1210

--[[ TO DO:

	- Change strings in BuffMeta to SpellIDs
	
	 
]]

-- GENERAL INFORMATION --======================================================

local BuffCheck_Name, bc = ...
	-- BuffCheck_Name = "BuffCheck"
	-- BuffCheck = {}

-- BUFF TABLES --=============================================================

--[[ ***NOTE TO DEVS:
 
	- To add buffs to check for, entries must be made in both the bc.Buffs.Index 
	  table and the local buff tables listed directly below.
]]

-- Buff list (1)

local Food = {"Well Fed"} -- Modify to differentiate between +125 and +100

local GreaterFlasks = {
    "Greater Draenic Agility Flask",
    "Greater Draenic Intellect Flask",
    "Greater Draenic Strength Flask",
    "Greater Draenic Stamina Flask"
}
local Stats = {
    "Mark of the Wild",
	"Legacy of the Emperor",
	"Legacy of the White Tiger",
	"Blessing of Kings",
	"Lone Wolf: Power of the Primates",
	"Bark of the Wild",
	"Blessing of Kongs",
	"Embrace of the Shale Spider",
	"Strength of the Earth"
}
local Stam = {
    "Power Word: Fortitude",
    "Blood Pact",
    "Commanding Shout",
    "Lone Wolf: Fortitude of the Bear",
    "Invigorating Roar",
    "Sturdiness",
    "Savage Vigor",
    "Qiraji Fortitude"
}
local Ap = {
    "Trueshot Aura",
	 "Battle Shout",
	 "Horn of Winter"
}
local Sp = {
    "Arcane Brilliance",
	 "Dalaran Brilliance",
	 "Dark Intent",
	 "Lone Wolf: Wisdom of the Serpent",
	 "Serpent's Cunning",
	 "Qiraji Fortitude",
	 "Still Water"
}
local Mastery = {
    "Grace of Air",
    "Moonkin Aura",
    "Blessing of Might",
    "Power of the Grave",
    "Lone Wolf: Grace of the Cat",
    "Roar of Courage",
    "Keen Senses",
    "Spirit Beast Blessing",
    "Plainswalking"
}
local Haste = {
    "Unholy Aura",
    "Mind Quickening",
    "Swiftblade's Cunning",
    "Grace of Air",
    "Lone Wolf: Haste of the Hyena",
    "Cackling Howl",
    "Savage Vigor",
    "Energizing Spores",
    "Speed of the Swarm"
}
local Crit = {
    "Leader of the Pack",
    "Arcane Brilliance",
    "Dalaran Brilliance",
    "Legacy of the White Tiger",
    "Lone Wolf: Ferocity of the Raptor",
    "Terrifying Roar",
    "Fearless Roar",
    "Strength of the Pack",
    "Embrace of the Shale Spider",
    "Still Water",
    "Furious Howl"
}
local Multi = {
    "Dark Intent",
    "Windflurry",
    "Mind Quickening",
    "Swiftblade's Cunning",
    "Lone Wolf: Quickness of the Dragonhawk",
    "Sonic Focus",
    "Wild Strength",
    "Double Bite",
    "Spry Attacks",
    "Breath of the Winds"
}
local Vers = {
    "Mark of the Wild",
    "Unholy Aura",
    "Sanctity Aura",
    "Inspiring Presence",
    "Lone Wolf: Versatility of the Ravager",
    "Tenacity",
    "Indomitable",
    "Wild Strength",
    "Defensive Quills",
    "Chitinous Armor",
    "Grace",
    "Strength of the Earth"
}
local Rune = {
    "Stout Augmentation",
    "Focus Augmentation",
    "Hyper Augmentation"
				 
}
--[[ Other Buffs (not implemented yet)
local RegularFlasks = {
    "Draenic Agility Flask",
    "Draenic Intellect Flask",
    "Draenic Stamina Flask"
]]

-- BUFF FUNCTIONS --===========================================================

-------------------------------------------------------------------------------
-- Returns whether a buff was found on a unit (boolean)
-- Checked against a specific buff table (i.e. 'TableName').
-------------------------------------------------------------------------------
local IsBuffFound = function (Unit, BuffTbl)
	
	local i=1
	local j=1
	local Buff = (select(1,UnitBuff(Unit,j)))
	
	while BuffTbl[i] do
		j = 1
		Buff = (select(1,UnitBuff(Unit,j)))
		while Buff do
			if BuffTbl[i] == Buff then
				return true
			end
			j = j + 1
			Buff = (select(1,UnitBuff(Unit,j)))
		end
		i = i + 1
	end
	
	

	return false
	
end

bc.FillMissingTbls = function(Unit)
	
	for j in pairs(bc.Buffs.Index) do
		local BuffType = bc.Buffs.Index[j]["Name"]
		if BuffCheck_ActiveSettings.BuffStatus[BuffType] then
			if not IsBuffFound(Unit, bc.Buffs.Index[j]["BuffTbl"]) then
				table.insert(bc.Buffs.Index[j]["MissingTbl"], (select(1,UnitName(Unit))) )
			end
		end
	end
	
end

-------------------------------------------------------------------------------
-- Holds all settings and functions relating to each buff type/category (TABLE).
-- (3)
-------------------------------------------------------------------------------
bc.Buffs = {
	
	NumTotalBuffs = function ()
	
		local NumBuffs = 0
		
		for i in pairs(bc.Buffs.Index) do
			if bc.Buffs.Index[i] ~= nil then
				NumBuffs = NumBuffs + 1
			end
		end
		
		return NumBuffs
	end,
	
	-- Counts number of enabled buffs
	NumEnabledBuffs = function ()
		
		local NumEnabled = 0

		for i in pairs(bc.Buffs.Index) do	
			local BuffName = bc.Buffs.Index[i]["Name"]
			
			if BuffCheck_ActiveSettings.BuffStatus[BuffName] then
				NumEnabled = NumEnabled + 1
			end
		end
		
		return NumEnabled
	end,
	
	Length = function(Tbl)
	
		local NumMissing = 0
		
		for i in pairs(Tbl) do	
			
			if Tbl[i] then
				NumMissing = NumMissing + 1
			end
		end
		
		return NumMissing
	
	end,
	
	-- Enables and disables buffs to check for
	SetBuffStatus = function (Buff, IsEnabled)
		if (Buff == "ALL") then
			for BuffName in pairs(BuffCheck_ActiveSettings.BuffStatus) do
				BuffCheck_ActiveSettings.BuffStatus[BuffName] = IsEnabled
			end
		else
			if not IsEnabled then
				BuffCheck_ActiveSettings.BuffStatus[Buff] = false
			else
				BuffCheck_ActiveSettings.BuffStatus[Buff] = true
			end
			
		end
	end,
	
	-------------------------------------------------------------------------------
	-- Clears all missing buff tables by setting them to nil (void).
	-------------------------------------------------------------------------------
	Clear = function ()
				
		for i in pairs(bc.Buffs.Index) do
			bc.Buffs.Index[i]["MissingTbl"] = {}
		end
		
	end,
	
	-------------------------------------------------------------------------------
	-- Returns whether all buffs are found on the player or group (boolean).
	-- Function has been modified --> TEST FIRST
	-------------------------------------------------------------------------------
	AllBuffsFound = function ()

		for i in pairs(bc.Buffs.Index) do
			for j in pairs(bc.Buffs.Index[i]["MissingTbl"]) do
				if bc.Buffs.Index[i]["MissingTbl"][j] then
					return false
				end
			end
		end
		
		return true

	end,
	
	-- Buff Tables and Attributes
	Index = {
	
		Food = {
			Name = "Food",
			Label = "<Food>",
			BuffTbl = Food,
			MissingTbl = {} 

		},
		
		GreaterFlasks = {
			Name = "GreaterFlasks",
			Label = "<Greater Flask>",
			BuffTbl = GreaterFlasks,
			MissingTbl = {}

		},
		
		Stats = {
			Name = "Stats",
			Label = "<Stats>",
			BuffTbl = Stats,
			MissingTbl = {}

		},

		Stam = {
			Name = "Stam",
			Label = "<Stamina>",
			BuffTbl = Stam,
			MissingTbl = {}
			
		},

		Ap = {
			Name = "Ap",
			Label = "<Attack Power>",
			BuffTbl = Ap,
			MissingTbl = {}

		},

		Sp = {
			Name = "Sp",
			Label = "<Spell Power>",
			BuffTbl = Sp,
			MissingTbl = {}

		},

		Mastery = {
			Name = "Mastery",
			Label = "<Mastery>",
			BuffTbl = Mastery,
			MissingTbl = {}
			
		},

		Haste = {
			Name = "Haste",
			Label = "<Haste>",
			BuffTbl = Haste,
			MissingTbl = {}
			
		},

		Crit = {
			Name = "Crit",
			Label = "<Critical Strike>",
			BuffTbl = Crit,
			MissingTbl = {}

		},

		Multi = {
			Name = "Multi",
			Label = "<Multistrike>",
			BuffTbl = Multi,
			MissingTbl = {}

		},
		
		Vers = {
			Name = "Vers",
			Label = "<Versatility>",
			BuffTbl = Vers,
			MissingTbl = {}

		},

		Rune = {
			Name = "Rune",
			Label = "<Augment Rune>",
			BuffTbl = Rune,
			MissingTbl = {}

		}
	}
	
}
